install.sh 7.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. cur_dir=$(pwd)
  7. # check root
  8. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  9. # Check OS and set release variable
  10. if [[ -f /etc/os-release ]]; then
  11. source /etc/os-release
  12. release=$ID
  13. elif [[ -f /usr/lib/os-release ]]; then
  14. source /usr/lib/os-release
  15. release=$ID
  16. else
  17. echo "Failed to check the system OS, please contact the author!" >&2
  18. exit 1
  19. fi
  20. echo "The OS release is: $release"
  21. arch3xui() {
  22. case "$(uname -m)" in
  23. x86_64 | x64 | amd64) echo 'amd64' ;;
  24. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  25. armv7* | armv7 | arm | arm32 ) echo 'arm32' ;;
  26. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  27. esac
  28. }
  29. echo "arch: $(arch3xui)"
  30. os_version=""
  31. os_version=$(grep -i version_id /etc/os-release | cut -d \" -f2 | cut -d . -f1)
  32. if [[ "${release}" == "centos" ]]; then
  33. if [[ ${os_version} -lt 8 ]]; then
  34. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  35. fi
  36. elif [[ "${release}" == "ubuntu" ]]; then
  37. if [[ ${os_version} -lt 20 ]]; then
  38. echo -e "${red}please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  39. fi
  40. elif [[ "${release}" == "fedora" ]]; then
  41. if [[ ${os_version} -lt 36 ]]; then
  42. echo -e "${red}please use Fedora 36 or higher version!${plain}\n" && exit 1
  43. fi
  44. elif [[ "${release}" == "debian" ]]; then
  45. if [[ ${os_version} -lt 10 ]]; then
  46. echo -e "${red} Please use Debian 10 or higher ${plain}\n" && exit 1
  47. fi
  48. elif [[ "${release}" == "arch" ]]; then
  49. echo "Your OS is ArchLinux"
  50. elif [[ "${release}" == "manjaro" ]]; then
  51. echo "Your OS is Manjaro"
  52. elif [[ "${release}" == "armbian" ]]; then
  53. echo "Your OS is Armbian"
  54. else
  55. echo -e "${red}Failed to check the OS version, please contact the author!${plain}" && exit 1
  56. fi
  57. install_base() {
  58. case "${release}" in
  59. centos|fedora)
  60. yum -y update && yum install -y -q wget curl tar
  61. ;;
  62. arch|manjaro)
  63. pacman -Syu && pacman -Syu --noconfirm wget curl tar
  64. ;;
  65. *)
  66. apt-get update && apt-get upgrade -y && apt install -y -q wget curl tar
  67. ;;
  68. esac
  69. }
  70. # This function will be called when user installed x-ui out of security
  71. config_after_install() {
  72. echo -e "${yellow}Install/update finished! For security it's recommended to modify panel settings ${plain}"
  73. read -p "Do you want to continue with the modification [y/n]?": config_confirm
  74. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  75. read -p "Please set up your username:" config_account
  76. echo -e "${yellow}Your username will be:${config_account}${plain}"
  77. read -p "Please set up your password:" config_password
  78. echo -e "${yellow}Your password will be:${config_password}${plain}"
  79. read -p "Please set up the panel port:" config_port
  80. echo -e "${yellow}Your panel port is:${config_port}${plain}"
  81. echo -e "${yellow}Initializing, please wait...${plain}"
  82. /usr/local/x-ui/x-ui setting -username ${config_account} -password ${config_password}
  83. echo -e "${yellow}Account name and password set successfully!${plain}"
  84. /usr/local/x-ui/x-ui setting -port ${config_port}
  85. echo -e "${yellow}Panel port set successfully!${plain}"
  86. else
  87. echo -e "${red}cancel...${plain}"
  88. if [[ ! -f "/etc/x-ui/x-ui.db" ]]; then
  89. local usernameTemp=$(head -c 6 /dev/urandom | base64)
  90. local passwordTemp=$(head -c 6 /dev/urandom | base64)
  91. /usr/local/x-ui/x-ui setting -username ${usernameTemp} -password ${passwordTemp}
  92. echo -e "this is a fresh installation,will generate random login info for security concerns:"
  93. echo -e "###############################################"
  94. echo -e "${green}username:${usernameTemp}${plain}"
  95. echo -e "${green}password:${passwordTemp}${plain}"
  96. echo -e "###############################################"
  97. echo -e "${red}if you forgot your login info,you can type x-ui and then type 7 to check after installation${plain}"
  98. else
  99. echo -e "${red} this is your upgrade,will keep old settings,if you forgot your login info,you can type x-ui and then type 7 to check${plain}"
  100. fi
  101. fi
  102. /usr/local/x-ui/x-ui migrate
  103. }
  104. install_x-ui() {
  105. cd /usr/local/
  106. if [ $# == 0 ]; then
  107. last_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  108. if [[ ! -n "$last_version" ]]; then
  109. echo -e "${red}Failed to fetch x-ui version, it maybe due to Github API restrictions, please try it later${plain}"
  110. exit 1
  111. fi
  112. echo -e "Got x-ui latest version: ${last_version}, beginning the installation..."
  113. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch3xui).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch3xui).tar.gz
  114. if [[ $? -ne 0 ]]; then
  115. echo -e "${red}Downloading x-ui failed, please be sure that your server can access Github ${plain}"
  116. exit 1
  117. fi
  118. else
  119. last_version=$1
  120. url="https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch3xui).tar.gz"
  121. echo -e "Begining to install x-ui $1"
  122. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch3xui).tar.gz ${url}
  123. if [[ $? -ne 0 ]]; then
  124. echo -e "${red}Download x-ui $1 failed,please check the version exists ${plain}"
  125. exit 1
  126. fi
  127. fi
  128. if [[ -e /usr/local/x-ui/ ]]; then
  129. systemctl stop x-ui
  130. rm /usr/local/x-ui/ -rf
  131. fi
  132. tar zxvf x-ui-linux-$(arch3xui).tar.gz
  133. rm x-ui-linux-$(arch3xui).tar.gz -f
  134. cd x-ui
  135. chmod +x x-ui bin/xray-linux-$(arch3xui)
  136. cp -f x-ui.service /etc/systemd/system/
  137. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  138. chmod +x /usr/local/x-ui/x-ui.sh
  139. chmod +x /usr/bin/x-ui
  140. config_after_install
  141. #echo -e "If it is a new installation, the default web port is ${green}2053${plain}, The username and password are ${green}admin${plain} by default"
  142. #echo -e "Please make sure that this port is not occupied by other procedures,${yellow} And make sure that port 2053 has been released${plain}"
  143. # echo -e "If you want to modify the 2053 to other ports and enter the x-ui command to modify it, you must also ensure that the port you modify is also released"
  144. #echo -e ""
  145. #echo -e "If it is updated panel, access the panel in your previous way"
  146. #echo -e ""
  147. systemctl daemon-reload
  148. systemctl enable x-ui
  149. systemctl start x-ui
  150. echo -e "${green}x-ui ${last_version}${plain} installation finished, it is running now..."
  151. echo -e ""
  152. echo -e "x-ui control menu usages: "
  153. echo -e "----------------------------------------------"
  154. echo -e "x-ui - Enter Admin menu"
  155. echo -e "x-ui start - Start x-ui"
  156. echo -e "x-ui stop - Stop x-ui"
  157. echo -e "x-ui restart - Restart x-ui"
  158. echo -e "x-ui status - Show x-ui status"
  159. echo -e "x-ui enable - Enable x-ui on system startup"
  160. echo -e "x-ui disable - Disable x-ui on system startup"
  161. echo -e "x-ui log - Check x-ui logs"
  162. echo -e "x-ui banlog - Check Fail2ban ban logs"
  163. echo -e "x-ui update - Update x-ui"
  164. echo -e "x-ui install - Install x-ui"
  165. echo -e "x-ui uninstall - Uninstall x-ui"
  166. echo -e "----------------------------------------------"
  167. }
  168. echo -e "${green}Running...${plain}"
  169. install_base
  170. install_x-ui $1